function averageSoundVelocity = getAverageSoundVelocity(linkDistanceInMeters)
    ctdFile = sprintf('data/CTD_%d.dat', linkDistanceInMeters);
    if (not(exist(ctdFile, 'file')))
        s = sprintf('CTD file %s does not exist.', ctdFile);
        disp(s);
        averageSoundVelocity = -1;
        return;
    end
    ctdData = dlmread(ctdFile);
    depth = ctdData(:,2);
    temperature = ctdData(:,3);
    salinity = ctdData(:,5);
    velocity = 1449.2 + 4.6*temperature - 5.5 * 10^-2 * temperature.^2 + ...
        2.9 * 10^-4 * temperature.^3 + (1.34 - 10^-2*temperature).*(salinity-35) + 1.6*10^-2*depth;
    averageSoundVelocity = mean(velocity);