function noiseLevelDB = getNoiseLevelDB(noiseFile, centerFrequencyHz, symbolsPerSecond, modulationType, useAmbientNoise)
    if (not(exist(noiseFile, 'file')))
        s = sprintf('Noise file %s does not exist.', noiseFile);
        disp(s);
        noiseLevelDB = -1;
        return;
    end
    noise = csvread(noiseFile);

    if (useAmbientNoise)
        noiseType = 7;
    else
        noiseType = randi(5,1,1)+1;
    end

    range = [(centerFrequencyHz - symbolsPerSecond) (centerFrequencyHz + symbolsPerSecond)];
    if (strcmpi(modulationType, 'PSK'))
        range = [(centerFrequencyHz - 3 * symbolsPerSecond / 2) (centerFrequencyHz + 3 * symbolsPerSecond / 2)];
    end

    index = find(and(noise(:,1) >= range(1)/1000,noise(:,1) <= range(2)/1000));
    len = length(index);
    if (len == 0)
        if (range(1) < noise(1,1))
            index = 1;
        end
        if (range(2) > noise(end,1))
            index = len;
        end
    end
    noiseLevelDB = 10 * log10(sum(10.^(noise(index, noiseType) / 10)) / len);