function [y] = hardlimit(x)
%HARDLIMIT limits the amplitude of a signal.
%   As indicated in,
%   J. Jones, "Hard-Limiting of Two Signals in Random Noise,"
%   IEEE Trans. on Information Theory, Vol. 9, Iss. 1, pp. 34–42, Jan. 1963,
%   the ideal limiter is described by its amplitude characteristic g(x),
%   with which the limiter output y(t) can be expressed uniquely in terms
%   of the input as
%   y(t) = g[x(t)] = {+1, 0, -1} if x(t) {> 0, = 0, < 0}.

    y = 2 * ((x > 0) - 0.5);