/*
 * MATLAB Compiler: 4.14 (R2010b)
 * Date: Wed Apr  6 20:18:48 2011
 * Arguments: "-B" "macro_default" "-B" "csharedlib:libchannel" "-W"
 * "lib:libchannel" "-T" "link:lib" "-v" "getAverageSoundVelocity.m"
 * "getNoiseLevelDB.m" "getTransmissionLossDB.m" "simulateChannel.m" "fconv.m" 
 */

#ifndef __libchannel_h
#define __libchannel_h 1

#if defined(__cplusplus) && !defined(mclmcrrt_h) && defined(__linux__)
#  pragma implementation "mclmcrrt.h"
#endif
#include "mclmcrrt.h"
#ifdef __cplusplus
extern "C" {
#endif

#if defined(__SUNPRO_CC)
/* Solaris shared libraries use __global, rather than mapfiles
 * to define the API exported from a shared library. __global is
 * only necessary when building the library -- files including
 * this header file to use the library do not need the __global
 * declaration; hence the EXPORTING_<library> logic.
 */

#ifdef EXPORTING_libchannel
#define PUBLIC_libchannel_C_API __global
#else
#define PUBLIC_libchannel_C_API /* No import statement needed. */
#endif

#define LIB_libchannel_C_API PUBLIC_libchannel_C_API

#elif defined(_HPUX_SOURCE)

#ifdef EXPORTING_libchannel
#define PUBLIC_libchannel_C_API __declspec(dllexport)
#else
#define PUBLIC_libchannel_C_API __declspec(dllimport)
#endif

#define LIB_libchannel_C_API PUBLIC_libchannel_C_API


#else

#define LIB_libchannel_C_API

#endif

/* This symbol is defined in shared libraries. Define it here
 * (to nothing) in case this isn't a shared library. 
 */
#ifndef LIB_libchannel_C_API 
#define LIB_libchannel_C_API /* No special import/export declaration */
#endif

extern LIB_libchannel_C_API 
bool MW_CALL_CONV libchannelInitializeWithHandlers(
       mclOutputHandlerFcn error_handler, 
       mclOutputHandlerFcn print_handler);

extern LIB_libchannel_C_API 
bool MW_CALL_CONV libchannelInitialize(void);

extern LIB_libchannel_C_API 
void MW_CALL_CONV libchannelTerminate(void);



extern LIB_libchannel_C_API 
void MW_CALL_CONV libchannelPrintStackTrace(void);

extern LIB_libchannel_C_API 
bool MW_CALL_CONV mlxGetAverageSoundVelocity(int nlhs, mxArray *plhs[], int nrhs, mxArray 
                                             *prhs[]);

extern LIB_libchannel_C_API 
bool MW_CALL_CONV mlxGetNoiseLevelDB(int nlhs, mxArray *plhs[], int nrhs, mxArray 
                                     *prhs[]);

extern LIB_libchannel_C_API 
bool MW_CALL_CONV mlxGetTransmissionLossDB(int nlhs, mxArray *plhs[], int nrhs, mxArray 
                                           *prhs[]);

extern LIB_libchannel_C_API 
bool MW_CALL_CONV mlxSimulateChannel(int nlhs, mxArray *plhs[], int nrhs, mxArray 
                                     *prhs[]);

extern LIB_libchannel_C_API 
bool MW_CALL_CONV mlxFconv(int nlhs, mxArray *plhs[], int nrhs, mxArray *prhs[]);

extern LIB_libchannel_C_API 
long MW_CALL_CONV libchannelGetMcrID();



extern LIB_libchannel_C_API bool MW_CALL_CONV mlfGetAverageSoundVelocity(int nargout, mxArray** averageSoundVelocity, mxArray* linkDistanceInMeters);

extern LIB_libchannel_C_API bool MW_CALL_CONV mlfGetNoiseLevelDB(int nargout, mxArray** noiseLevelDB, mxArray* noiseFile, mxArray* centerFrequencyHz, mxArray* symbolsPerSecond, mxArray* modulationType, mxArray* useAmbientNoise);

extern LIB_libchannel_C_API bool MW_CALL_CONV mlfGetTransmissionLossDB(int nargout, mxArray** transmissionLossDB, mxArray* linkDistanceInMeters);

extern LIB_libchannel_C_API bool MW_CALL_CONV mlfSimulateChannel(int nargout, mxArray** samples, mxArray** numberOfSamples, mxArray* packetWaveform, mxArray* impulseResponseFileName, mxArray* snr, mxArray* fs);

extern LIB_libchannel_C_API bool MW_CALL_CONV mlfFconv(int nargout, mxArray** y, mxArray* x, mxArray* h, mxArray* normalize);

#ifdef __cplusplus
}
#endif
#endif
