/*
 * MATLAB Compiler: 4.14 (R2010b)
 * Date: Wed Apr  6 20:19:10 2011
 * Arguments: "-B" "macro_default" "-B" "csharedlib:libphy" "-W" "lib:libphy"
 * "-T" "link:lib" "-v" "modulateFSK.m" "demodulateFSK.m" "modulatePSK.m"
 * "demodulatePSK.m" "chirp.m" "filterSignal.m" "hardlimit.m" 
 */

#ifndef __libphy_h
#define __libphy_h 1

#if defined(__cplusplus) && !defined(mclmcrrt_h) && defined(__linux__)
#  pragma implementation "mclmcrrt.h"
#endif
#include "mclmcrrt.h"
#ifdef __cplusplus
extern "C" {
#endif

#if defined(__SUNPRO_CC)
/* Solaris shared libraries use __global, rather than mapfiles
 * to define the API exported from a shared library. __global is
 * only necessary when building the library -- files including
 * this header file to use the library do not need the __global
 * declaration; hence the EXPORTING_<library> logic.
 */

#ifdef EXPORTING_libphy
#define PUBLIC_libphy_C_API __global
#else
#define PUBLIC_libphy_C_API /* No import statement needed. */
#endif

#define LIB_libphy_C_API PUBLIC_libphy_C_API

#elif defined(_HPUX_SOURCE)

#ifdef EXPORTING_libphy
#define PUBLIC_libphy_C_API __declspec(dllexport)
#else
#define PUBLIC_libphy_C_API __declspec(dllimport)
#endif

#define LIB_libphy_C_API PUBLIC_libphy_C_API


#else

#define LIB_libphy_C_API

#endif

/* This symbol is defined in shared libraries. Define it here
 * (to nothing) in case this isn't a shared library. 
 */
#ifndef LIB_libphy_C_API 
#define LIB_libphy_C_API /* No special import/export declaration */
#endif

extern LIB_libphy_C_API 
bool MW_CALL_CONV libphyInitializeWithHandlers(
       mclOutputHandlerFcn error_handler, 
       mclOutputHandlerFcn print_handler);

extern LIB_libphy_C_API 
bool MW_CALL_CONV libphyInitialize(void);

extern LIB_libphy_C_API 
void MW_CALL_CONV libphyTerminate(void);



extern LIB_libphy_C_API 
void MW_CALL_CONV libphyPrintStackTrace(void);

extern LIB_libphy_C_API 
bool MW_CALL_CONV mlxModulateFSK(int nlhs, mxArray *plhs[], int nrhs, mxArray *prhs[]);

extern LIB_libphy_C_API 
bool MW_CALL_CONV mlxDemodulateFSK(int nlhs, mxArray *plhs[], int nrhs, mxArray *prhs[]);

extern LIB_libphy_C_API 
bool MW_CALL_CONV mlxModulatePSK(int nlhs, mxArray *plhs[], int nrhs, mxArray *prhs[]);

extern LIB_libphy_C_API 
bool MW_CALL_CONV mlxDemodulatePSK(int nlhs, mxArray *plhs[], int nrhs, mxArray *prhs[]);

extern LIB_libphy_C_API 
bool MW_CALL_CONV mlxChirp(int nlhs, mxArray *plhs[], int nrhs, mxArray *prhs[]);

extern LIB_libphy_C_API 
bool MW_CALL_CONV mlxFilterSignal(int nlhs, mxArray *plhs[], int nrhs, mxArray *prhs[]);

extern LIB_libphy_C_API 
bool MW_CALL_CONV mlxHardlimit(int nlhs, mxArray *plhs[], int nrhs, mxArray *prhs[]);

extern LIB_libphy_C_API 
long MW_CALL_CONV libphyGetMcrID();



extern LIB_libphy_C_API bool MW_CALL_CONV mlfModulateFSK(int nargout, mxArray** txFSK, mxArray** numberOfSamples, mxArray* byteStream, mxArray* fs, mxArray* fc, mxArray* symbolsPerSecond);

extern LIB_libphy_C_API bool MW_CALL_CONV mlfDemodulateFSK(int nargout, mxArray** rxFSK, mxArray* packetWaveform, mxArray* numberOfBytes, mxArray* fs, mxArray* fc, mxArray* symbolsPerSecond, mxArray* receiverType, mxArray* useLimiter);

extern LIB_libphy_C_API bool MW_CALL_CONV mlfModulatePSK(int nargout, mxArray** txPSK, mxArray** numberOfSamples, mxArray* byteStream, mxArray* fs, mxArray* fc, mxArray* symbolsPerSecond);

extern LIB_libphy_C_API bool MW_CALL_CONV mlfDemodulatePSK(int nargout, mxArray** rxPSK, mxArray* packetWaveform, mxArray* numberOfBytes, mxArray* fs, mxArray* fc, mxArray* symbolsPerSecond);

extern LIB_libphy_C_API bool MW_CALL_CONV mlfChirp(int nargout, mxArray** y, mxArray** time, mxArray* startFreq, mxArray* endFreq, mxArray* samplingRate, mxArray* numSeconds, mxArray* method);

extern LIB_libphy_C_API bool MW_CALL_CONV mlfFilterSignal(int nargout, mxArray** y, mxArray* x, mxArray* samplingRate, mxArray* freq, mxArray* symbolsPerSecond);

extern LIB_libphy_C_API bool MW_CALL_CONV mlfHardlimit(int nargout, mxArray** y, mxArray* x);

#ifdef __cplusplus
}
#endif
#endif
