function [samples numberOfSamples] = simulateChannel(packetWaveform, impulseResponseFileName, snr, fs)
    [ir fsFile ~] = wavread(impulseResponseFileName);
    if (fsFile ~= fs)
        s = sprintf('Error: Sampling rate of impulse response does not match rate of incoming packet');
        disp(s);
        samples = [];
        numberOfSamples = 0;
        return;
    end
    ir = ir';
    samples = fconv(packetWaveform, ir);
    samples = awgn(samples, snr);
    numberOfSamples = length(samples);