/**
 * test.c
 * Calls a MATLAB Compiler generated shared library.
 */
#include "libchannel.h"
#include <stdio.h>

int main(void) {
    mxArray *x_ptr;
    mxArray *y_ptr = NULL;

    if (!mclInitializeApplication(NULL,0)) {
        fprintf(stderr, "Could not initialize the application.\n");
    	return -1;
    }

    /* Create an mxArray to input into mlfGetTransmissionLossDB */
    x_ptr = mxCreateDoubleScalar(505);

    /* Call the library initialization function */
    libchannelInitialize();

    /* Call the implementation function mlfGetTransmissionLossDB */
    mlfGetTransmissionLossDB(1, &y_ptr, x_ptr);

    /* Call the library termination function */
    libchannelTerminate();

    printf("Transmission loss: %.2f dB\n", mxGetPr(y_ptr)[0]);

    mclTerminateApplication();
    return 0;
}

