/*************************************************************************
 *
 * Computes the 16-bit Cyclic Redundancy Check (CRC16) for an array of bytes.
 * Uses a lookup table.
 *
 * Reference:  http://www.gelato.unsw.edu.au/lxr/source/lib/crc16.c
 *
 * Uses irreducible polynomial:  1 + x^2 + x^15 + x^16
 *
 *************************************************************************/
#ifndef CRC16_H_
#define CRC16_H_

class CRC16 {
    public:
        static unsigned short getChecksum(unsigned char charArray[], int length);
    private:
        static const unsigned short table[];
};

#endif
