//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program.  If not, see http://www.gnu.org/licenses/.
//

#ifndef UWCHANNEL_H_
#define UWCHANNEL_H_

#include <cchannel.h>

class UWChannel: public cChannel {
    public:
        UWChannel();
        virtual ~UWChannel();

        virtual bool isTransmissionChannel() const {return false;}
        virtual bool deliver(cMessage *msg, simtime_t at);
        virtual simtime_t calculateDuration(cMessage *msg) const {return 0;}
        virtual simtime_t getTransmissionFinishTime() const {return simTime();}
    protected:
        virtual void initialize();
    private:
        double linkDistanceInMeters;
        double soundVelocityInMetersPerSecond;
        double propagationDelayInSeconds;
        bool useAmbientNoise;
};

#endif /* UWCHANNEL_H_ */
